.TH mccs  1 "9 May 2011" "" "Debian User's Manual"

.SH NAME
mccs \- package dependency solver

.SH SYNOPSIS
.B mccs
.RI [ options ]
.br

.SH DESCRIPTION
mccs (which stands for Multi Criteria CUDF Solver) is a solver for
package dependency problems expressed in the CUDF format. By default,
mccs reads a problem specification from standard input, and writes
the solution to standard output.

.SH OPTIONS FOR CONTROLLING INPUT/OUTPUT
.TP
.B \-i \fIfile\fR
Read input from file \fIfile\fR instead of standard input.
.TP
.B \-o \fIfile\fR
Write the solution to \fIfile\fR instead of standard output.
.TP
.B \-fo
full solution output
.TP 
.B \-v \fIn\fR
set verbosity level to \fIn\fR.
.TP
.B \-h
print this help

.SH OPTIONS FOR SELECTING THE SOLVER ENGINE
By default, mccs uses the cbc solving engine.
.TP
.B \-lpsolve
use lpsolve solver
.TP
.B \-lp \fIlpsolver\fR
specify a solving engine that takes the cplex input format. \fIlpsolver\fR is
the path of a script that takes as input the file name containing the
cplex input, and that produces the solution on standard output
(an example for scip is given in /usr/share/doc/mccs/engines/sciplp).
.TP
.B \-pblib \fIpbsolver\fR
use pseudo-Boolean solver \fIpbsolver\fR as solving engine. 
.TP 
.B \-nosolve
do not solve the problem (for debugging)

.SH OPTIONS FOR CONTROLLING CONSTRAINT GENERATION
.TP
.B \-noreduce
do not reduce the initial problem
.TP
.B \-only-agregate-constraints
generate only agregate constraints
.TP
.B \-only-desagregate-constraints
generate only deagregate constraints (default)
.TP
.B \-all-constraints
generate all kind of constraints (ensure redundancy)

.SH OPTIONS FOR CONTROLLING OPTIMIZATION
See the file /usr/share/doc/mccs/README.optimization-criteria for a full grammar
of optimization criteria.

.SH EXAMPLES

An example input file can be found at /usr/share/doc/mccs/examples/legacy.cudf.

    mccs -i legacy.cudf

calls mccs on examples/legacy.cudf and prints the solution on
stdout. With such a call mccs will resort to the default underlying
solver cbc and use a default criterion to solve the problem.

    mccs -i legacy.cudf -o sol -lexagregate[-removed,-changed]\\
    -lpsolve

Here, mccs puts the solution into the  file "sol" and solves the problem
using the lpsolve solver with the paranoid criterion, which consists of
first minimizing the number of removed packaged, and then the number of
packages that change installation status or installed version.

    mccs -i legacy.cudf -o sol \\
    -lexsemiagregate[-removed,-notuptodate,\\
    -nunsat[recommends:,true],-new]

The criterion used here is the trendy criterion, which consists of first
minimizing the number of package removals, then to minimize the number of
installed packages that are installed in a version older the most recent
available version, then to minimize the number of recommendations of
installed packages that are not satisfied, and finally the number of
newly installed packages. 
	
.SH AUTHOR
mccs has been written by Claude Michel <cpjm@polytech.unice.fr>. The
development of mccs has been partly supported by the European research
project Mancoosi.
